# -*- coding: utf-8 -*-
"""
The Executioner is a tool used for performing clean experiments by managing the output files generated by them.

The script will be launched from the output directory:
    - Every output should be stored here, when you choose the parameters of your script make sure it will write its
    output files in the current working directory (or subdirectories).
    - Every relative input file should be defined from the current working directory (where you launch the executioner).
It will then be converted to absolute path before changing the current working directory to the output directory to
know if a path is a path and should be changed to an absolute path, we only check for the existence of each parameter
on the file system (e.g. in `my_script --time --input input.txt`, --time doesn't exist nor --input but input.txt does,
it is then converted to /home/bidule/input.txt)

Usage:
    executioner --output-dir OUTPUT_DIR [--python INTERPRETER] [--walltime integer] --script SCRIPT [--params PARAMS | --array-params PARAMFILE] [--dry-run] [-i] [-S integer] [-N integer] [-h str] [-H str]

Options:
    -o --output-dir OUTPUT_DIR          The directory path where the output should be stored.
    -P --python INTERPRETER             The python interpreter path.
    -s --script SCRIPT                  The script path to be executed.
    -p --params PARAMS                  The parameters to be passed to the script.
    -a --array-params PARAMFILE         The path to a file containing an array of parameters
    -n --dry-run                        Tell the script not to be run but print the command lines instead
    -i --inner                          Tell if it is already inside an OAR job or not
    -S --start integer                  Tell at wich cmd line the executioner should start
    -N --job-number integer             Tell how many cmd line the executioner should launch
    -h --hash str                       Tell the key files that can appear in the names of files of the output dir when checking for emptyness.
    -H --host str                       The name of the cluster host where to launch the script.
    -t --walltime integer               Time in hour for the full oar job. [default: 60]
"""
import io
import os
import shutil
import subprocess
import sys
import time
from contextlib import redirect_stdout

import docopt
import pip

from skluc.main.tools.experiences.oarCmdGenerator import oarcmd
from skluc.main.utils import create_directory, logger


def prepare_output_dir(path_output_dir, hash=""):
    """
    Create and check content of the output directory

    :param path_output_dir: Path to the output directory.
    :return: None
    """
    create_directory(path_output_dir)
    if bool(os.listdir(path_output_dir)) and (not all([hash in fname for fname in os.listdir(path_output_dir)]) and hash != ""):
        str_error = "{} dir should be empty".format(path_output_dir)
        logger.error(str_error)
        raise FileExistsError(str_error)


def run(interpreter,
        output_dir,
        script,
        lst_params,
        dry_run,
        inner,
        hash,
        host=None,
        walltime=60
        ):
    """

    :param interpreter:
    :param output_dir:
    :param script:
    :param lst_params:
    :param dry_run:
    :param inner:
    :param hash:
    :param host: list of strings of the hosts
    :param walltime:
    :return:
    """
    start_time = time.time()

    interpreter = os.path.abspath(interpreter) if interpreter is not None else sys.executable
    if not dry_run:
        logger.info("Preparing output directory")
        prepare_output_dir(output_dir, hash)
        logger.info("Producing backup for reproducibility")
        reproducing_backup(output_dir, script, lst_params, start_time, hash)
        # go to the output directory before running the script
        os.chdir(output_dir)

    # run the script
    logger.info("Commands to be run:")
    nb_param = len(lst_params)

    i = 0
    while i < nb_param:
        param_line = lst_params[i]
        subprocess_list = [interpreter] + [script] + param_line
        if inner:
            cmd = subprocess_list
            stdout_file = os.path.join(output_dir, hash + "job_{}_{}_stdout.txt".format(start_time, i))
            stderr_file = os.path.join(output_dir, hash + "job_{}_{}_stderr.txt".format(start_time, i))
        else:
            stdout_file = os.path.join(output_dir, "main_output_stdout.txt")
            stderr_file = os.path.join(output_dir, "main_output_stderr.txt")
            cmd = oarcmd(gpu=True, command=" ".join(subprocess_list), host=host, output_dir=output_dir, time=walltime)

        if dry_run:
            logger.info(" ".join(cmd))
        else:
            logger.info(" ".join(cmd))
            subproc_obj = subprocess.Popen(cmd, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
            stdout, stder = subproc_obj.communicate()

            with open(stdout_file, 'a') as f:
                f.write(stdout.decode())
            with open(stderr_file, 'a') as f:
                f.write(stder.decode())
        i += 1


def reproducing_backup(path_output_dir, path_script_file, lst_params_script, start_time="", hash=""):
    """
    Perform steps to ensure reproducibility of the experiment.

    Copy environment spec, script and script parameters to the output directory.

    :param path_output_dir: Path to the output directory
    :param path_script_file: Path to the script file
    :param lst_params_script:
    :return:
    """
    REQUIREMENTS = str(hash) + str(start_time) + "requirements.txt"
    PARAMETERS = str(hash) + str(start_time) + "parameters.txt"
    # check if the script exist from the initial path
    if not os.path.exists(path_script_file):
        raise FileNotFoundError("The script file {} could not be found")

    # copy the script to the output directory (reproducibility)
    shutil.copy(path_script_file, os.path.join(path_output_dir, str(hash) + os.path.basename(os.path.normpath(path_script_file))))

    # get pip freeze output
    pip_freeze_output = io.StringIO()
    with redirect_stdout(pip_freeze_output):
        pip.main(['freeze'])
    str_pip_freeze_output = pip_freeze_output.getvalue()

    # write the pip freeze output to a file (reproducibility)
    with open(os.path.join(path_output_dir, REQUIREMENTS), "w") as f:
        f.write(str_pip_freeze_output + "\n")
    # write the parameters of the main script to a file (reproducibility)
    with open(os.path.join(path_output_dir, PARAMETERS), "w") as f:
        for line_params in lst_params_script:
            f.write(" ".join(line_params) + "\n")
    # todo devrait-on copier les fichiers d'inputs?


def process_script_params(params, path_array_params):
    def param_with_abspath(splited_params):
        tmp_params = []
        for param in splited_params:
            if os.path.exists(param):
                param = os.path.abspath(param)
            tmp_params.append(param)
        return tmp_params

    if params is not None:
        splited_params = params.split(" ")
        return [param_with_abspath(splited_params)]
    elif path_array_params is not None:
        array_params = []
        with open(path_array_params, "r") as f:
            line = f.readline()
            while line != "":
                stripped_line = line.strip()
                splited_line = stripped_line.split(" ")
                array_params.append(param_with_abspath(splited_line))
                line = f.readline()
        return array_params
    else:
        logger.debug("No params for the script")


if __name__ == '__main__':
    arguments = docopt.docopt(__doc__)
    OUTPUT_DIR = os.path.abspath(arguments["--output-dir"])
    SCRIPT = os.path.abspath(arguments["--script"])
    LST_PARAMS = process_script_params(arguments["--params"],
                                       os.path.abspath(arguments["--array-params"]) if arguments[
                                                                                           "--array-params"] is not None else None)
    # The default interpreter used for the script is the interpreter used for launching the executioner
    INTERPRETER = arguments["--python"]
    DRY_RUN = arguments["--dry-run"]
    INNER = arguments["--inner"]
    START = int(arguments["--start"]) if arguments["--start"] is not None else 0
    STOP = START + int(arguments["--job-number"]) if arguments["--job-number"] is not None else len(LST_PARAMS)

    LST_PARAMS = LST_PARAMS[START:STOP]
    HASH = arguments["--hash"]
    if arguments["--host"] is not None:
        HOST = [h.strip() for h in arguments["--host"].split(",")]
    else:
        HOST = arguments["--host"]
    if arguments["--walltime"] is not None:
        TIME = int(arguments["--walltime"])
    run(INTERPRETER, OUTPUT_DIR, SCRIPT, LST_PARAMS, DRY_RUN, INNER, hash=HASH, host=HOST, walltime=TIME)
